/* $Id: pbjtime.h,v 1.17 2003/05/28 18:50:54 chrisf Exp $ */

/*
PBJTime - Clock utility
Copyright (C) 2003 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __PBJTIME_H__
#define __PBJTIME_H__

#define MainAppID 'PBJT'
#define MainDBType 'DATA'
#define MainDBName "PBJTimeDB"

/* what size to cap the SMS field/rec */
#define MAX_TEXT_SIZE 4096

struct sprefs {
    UInt16 popupduration; /* seconds */
};

/* Features */
#define FTR_MAINDB 0
#define FTR_TONESTOPPED 1

/* Custom events */
#define EV_STOPLOOP (firstUserEvent+1)
#define EV_KEEPALIVE (firstUserEvent+2)

/* function prototypes */

Boolean is_jog(EventPtr e);
Boolean MainFormHandleEvent(EventPtr e);
Boolean PopupFormHandleEvent(EventPtr e);
Boolean PrefsFormHandleEvent(EventPtr e);
Boolean AboutFormHandleEvent(EventPtr e);
Boolean ContribFormHandleEvent(EventPtr e);
void DrawGadgets(FormPtr frm, Boolean forcedraw);
UInt16 GetDateText(UInt32 sec, char *txt);
UInt16 GetTimeText(UInt32 sec, char *txt);
void SetFieldHandles(FormPtr frm, DmOpenRef db);
void ClearFieldHandles(FormPtr frm);
void TextUpdateScrollBar(FormPtr frm, Boolean init);
void TextFieldScroll(FormPtr frm, Int16 linesToScroll);
void TextFieldPageScroll(FormPtr frm, WinDirectionType direction,
    Boolean onlyoneline);
FieldPtr GetFocusObjectPtr(void);
Boolean FormHandleMenuEvent(UInt16 menuID);
Boolean ApplicationHandleEvent(EventPtr e);
UInt16 StartApplication(void);
void StopApplication(void);
void EventLoop(void);
void LoadPrefs(struct sprefs *prefs);
void SavePrefs(struct sprefs *prefs);
void post_custom_event(UInt16 etype);
Boolean OpenDatabase(DmOpenRef *db);
void CloseDatabase(DmOpenRef db);
void SetTimeOfNextAlarm(UInt32 alarmTime, UInt32 ref, AlmAlarmProcPtr procP);
void DisplayAlarm(UInt16 launchFlags);
void treohelper_stop_tone(void);
UInt32 HandleLaunchCodes(UInt16 cmd, void *cmdPBP, UInt16 launchFlags);
UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 launchFlags);

#endif
